#region Using declarations
using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    /// <summary>
    /// Written by Tyler Moore - www.MooreTechLLC.com
    /// </summary>
    [Description("Written by Tyler Moore - www.MooreTechLLC.com")]
    public class ddTimeLine : Indicator
    {
        #region Variables        
        private TimeSpan lineTime = new TimeSpan(10,30,00);
        // User defined variables (add any user defined variables below)
        #endregion

        /// <summary>
        /// This method is used to configure the indicator and is called once before any bar data is loaded.
        /// </summary>
        protected override void Initialize()
        {            
            Overlay				= true;
        }

        /// <summary>
        /// Called on each bar update event (incoming tick)
        /// </summary>
        protected override void OnBarUpdate()
        {
            if (Time[0].TimeOfDay.CompareTo(lineTime)==0)
				DrawVerticalLine(CurrentBar.ToString(),0,Color.Blue,DashStyle.Solid,2);
        }

        #region Properties
        [Description("")]
        [GridCategory("Parameters")]
        public TimeSpan LineTime
        {
            get { return lineTime; }
            set { lineTime = value; }
        }
		
		[Browsable(false)]
		public string LineTimeS
		{
			get { return lineTime.ToString(); }
 			set { lineTime = TimeSpan.Parse(value); }
		}
		
        #endregion
    }
}

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private ddTimeLine[] cacheddTimeLine = null;

        private static ddTimeLine checkddTimeLine = new ddTimeLine();

        /// <summary>
        /// Written by Tyler Moore - www.MooreTechLLC.com
        /// </summary>
        /// <returns></returns>
        public ddTimeLine ddTimeLine(TimeSpan lineTime)
        {
            return ddTimeLine(Input, lineTime);
        }

        /// <summary>
        /// Written by Tyler Moore - www.MooreTechLLC.com
        /// </summary>
        /// <returns></returns>
        public ddTimeLine ddTimeLine(Data.IDataSeries input, TimeSpan lineTime)
        {
            if (cacheddTimeLine != null)
                for (int idx = 0; idx < cacheddTimeLine.Length; idx++)
                    if (cacheddTimeLine[idx].LineTime == lineTime && cacheddTimeLine[idx].EqualsInput(input))
                        return cacheddTimeLine[idx];

            lock (checkddTimeLine)
            {
                checkddTimeLine.LineTime = lineTime;
                lineTime = checkddTimeLine.LineTime;

                if (cacheddTimeLine != null)
                    for (int idx = 0; idx < cacheddTimeLine.Length; idx++)
                        if (cacheddTimeLine[idx].LineTime == lineTime && cacheddTimeLine[idx].EqualsInput(input))
                            return cacheddTimeLine[idx];

                ddTimeLine indicator = new ddTimeLine();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.LineTime = lineTime;
                Indicators.Add(indicator);
                indicator.SetUp();

                ddTimeLine[] tmp = new ddTimeLine[cacheddTimeLine == null ? 1 : cacheddTimeLine.Length + 1];
                if (cacheddTimeLine != null)
                    cacheddTimeLine.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheddTimeLine = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Written by Tyler Moore - www.MooreTechLLC.com
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ddTimeLine ddTimeLine(TimeSpan lineTime)
        {
            return _indicator.ddTimeLine(Input, lineTime);
        }

        /// <summary>
        /// Written by Tyler Moore - www.MooreTechLLC.com
        /// </summary>
        /// <returns></returns>
        public Indicator.ddTimeLine ddTimeLine(Data.IDataSeries input, TimeSpan lineTime)
        {
            return _indicator.ddTimeLine(input, lineTime);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Written by Tyler Moore - www.MooreTechLLC.com
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ddTimeLine ddTimeLine(TimeSpan lineTime)
        {
            return _indicator.ddTimeLine(Input, lineTime);
        }

        /// <summary>
        /// Written by Tyler Moore - www.MooreTechLLC.com
        /// </summary>
        /// <returns></returns>
        public Indicator.ddTimeLine ddTimeLine(Data.IDataSeries input, TimeSpan lineTime)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.ddTimeLine(input, lineTime);
        }
    }
}
#endregion
